<template>
  <div
    style="transform: translate3d(0px, 0px, 0px) scale3d(1, 1, 1) rotateX(0deg) rotateY(0deg) rotateZ(0deg) skew(0deg, 0deg); opacity: 1; transform-style: preserve-3d;"
    class="dapp-card"
  >
    <div class="dapp-card-close-section" v-close-popup>
      <div class="close-dapp-card"></div>
    </div>
    <div class="dapp-card-icon-section">
      <div class="dapp-card-icon">
        <div
          class="app"
          :style="
            `backgroundImage: url('${app.imgixImageUrl || app.imageUrl}')`
          "
        ></div>
      </div>
    </div>
    <div class="dapp-card-name-section">
      <div>{{ app.name }}</div>
    </div>
    <div class="dapp-card-star-divider">
      <div
        class="dapp-card-star"
        @click="toggleFavorite(app.id)"
        :style="
          isFavorite(app.id)
            ? `backgroundImage: url('/statics/images/favorite.svg')`
            : ``
        "
        v-if="user !== null"
      ></div>
    </div>
    <div class="dapp-card-description-section">
      <div>{{ app.description }}</div>
    </div>
    <div class="dapp-card-category-section">
      <div class="text-block">{{ app.category }}</div>
    </div>
    <div class="dapp-card-standard-divider"></div>
    <div class="dapp-card-social-icons">
      <a :href="app.openSourceUrl" v-if="app.openSourceUrl">
        <div class="social-icon-github"></div>
      </a>
      <a
        :href="`https://twitter.com/${app.twitterHandle}`"
        target="_blank"
        rel="noreferrer"
        v-if="app.twitterHandle"
      >
        <div class="social-icon-twitter"></div>
      </a>
    </div>
    <a class="dapp-card-launch-button-section" :href="app.website" target="_blank" rel="noreferrer">
      <div class="dapp-card-launch-button">Launch now</div>
    </a>
  </div>
</template>

<script>
import { mapActions, mapGetters, mapState } from "vuex";
import { userSession } from "boot/blockstack";
export default {
  props: {
    app: {
      type: Object,
      default: () => {}
    }
  },
  computed: {
    ...mapState(["user"]),
    ...mapGetters({
      favorites: "favorites",
      favoriteIDs: "favoriteIDs"
    })
  },
  methods: {
    ...mapActions({
      addFavorite: "addFavorite",
      removeFavorite: "removeFavorite"
    }),
    isFavorite(id) {
      return this.favorites.find(fave => fave.id === id);
    },
    async toggleFavorite(id) {
      this.$q.loading.show();
      if (this.favoriteIDs.includes(id)) {
        await this.removeFavorite(id);
      } else {
        await this.addFavorite(id);
      }
      this.$q.loading.hide();
      userSession.putFile(
        "webby-favorites.json",
        JSON.stringify(this.favoriteIDs)
      );
    }
  }
};
</script>

<style scoped>
a {
  text-decoration: none;
}
</style>
